<?php

class Datasource_Moloni_Model_Observer extends Varien_Event_Observer
{
    /**
     * Magento passes a Varien_Event_Observer object as
     * the first parameter of dispatched events.
     */
	 
    public function genInvoice(Varien_Event_Observer $observer)
    {

		if($observer->getEvent()->getInvoice()->getStateName() == "Paid")
		{

			try{ 

				define("MOLONI_PATH", "./app/design/adminhtml/default/default/template/moloni");
				define("BASE_URL", Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_WEB));
				define("DB_PREFIX", Mage::getConfig()->getTablePrefix());

				$resource = Mage::getSingleton('core/resource');
				$execute = $resource->getConnection('core_write');

				$orderID = $observer->getEvent()->getInvoice()->getData('order_id');
				
				/****************** DEFINIÇÕES INICIAIS ********************/
				Mage::log($orderID." - A gerar automaticamente factura pelo observer - ". 
					$observer->getEvent()->getInvoice()->getData('increment_id'), 
					null, 'moloni.log'
				);		

						

						
				require_once(MOLONI_PATH."/classes/core.class.phtml");

				$moloni = start::init();

				if($moloni && AUTO_INVOICING){
					require_once(MOLONI_PATH."/classes/moloni.class.phtml");
					require_once(MOLONI_PATH."/classes/moloni.documents.phtml");
					require_once(MOLONI_PATH."/classes/moloni.entities.phtml");
					require_once(MOLONI_PATH."/classes/moloni.products.phtml");
					require_once(MOLONI_PATH."/classes/magento.class.phtml");

					$results = $execute->fetchRow("SELECT * FROM ".$resource->getTableName('sales_flat_order')." WHERE entity_id = '$orderID'");
					
					if(isset($results['increment_id']) && is_array($results)){
					    $documents = new documents();
						$invoice = $documents->invoiceMake($results);
						Mage::log($orderID." - Acção finalizada com sucesso ".$invoice, null, "moloni.log");
					}else{		
						Mage::log($orderID." - Query:" .$sqlQuery, null, "moloni.log");
						Mage::log($orderID." - Acção finalizada: ", null, "moloni.log");
					}
				}

			}catch(Exception  $e){
				Mage::log($e, null, "moloni.log");
				Mage::log("Acção finalizada com erro", null, "moloni.log");
			}

			return true;
		}
    }
}